package logopaint;

import java.io.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.image.renderable.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.util.*;

import javax.swing.*;
import javax.swing.table.*;

import com.sun.media.jai.codec.*;

import org.biojava.bio.gui.*;
import org.biojava.bio.dist.*;
import org.biojava.bio.symbol.*;
import org.biojava.bio.seq.*;

public class LogoPFrame extends JFrame {
  JPanel contentPane;
  JMenuBar jMenuBar1 = new JMenuBar();
  JMenu jMenuFile = new JMenu();
  JMenuItem jMenuFileExit = new JMenuItem();
  JMenu jMenuHelp = new JMenu();
  JMenuItem jMenuHelpAbout = new JMenuItem();
  JLabel statusBar = new JLabel();
  BorderLayout borderLayout1 = new BorderLayout();
  JScrollPane jScrollPane1 = new JScrollPane();
  JPanel jPanel1 = new JPanel();
  JMenu jMenuEdit = new JMenu();
  JMenuItem jMenuItem2 = new JMenuItem();
  FlowLayout flowLayout1 = new FlowLayout();
  TextLogoPainter2 tl2 = new TextLogoPainter2();
  JMenuItem jMenuItem1 = new JMenuItem();
  File currDir = new File(System.getProperty("user.home"));
  JMenuItem jMenuItem3 = new JMenuItem();
  JMenuItem jMenuItem4 = new JMenuItem();
  JTabbedPane jTabbedPane1 = new JTabbedPane();
  InfoBar infobar1 = new InfoBar();
  JScrollPane jScrollPane2 = new JScrollPane();
  JTable jTable1 = new JTable();
  String[] columnNames = new String[]{"A","C","G","U/T"};
  DefaultTableModel tmodel = new DefaultTableModel(columnNames,2);

  JMenuItem jMenuItem5 = new JMenuItem();
  JMenuItem jMenuItem6 = new JMenuItem();
  Dimension logoDimension = new Dimension(75,150);
  ArrayList distLogos = new ArrayList(10);
  JMenuItem jMenuItem7 = new JMenuItem();
  JMenuItem jMenuItem8 = new JMenuItem();

  /**Construct the frame*/
  public LogoPFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /**Component initialization*/
  private void jbInit() throws Exception  {
    //setIconImage(Toolkit.getDefaultToolkit().createImage(LogoPFrame.class.getResource("[Your Icon]")));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(borderLayout1);
    this.setSize(new Dimension(491, 312));
    this.setTitle("Logo Paint");
    statusBar.setText(" ");
    jMenuFile.setText("File");
    jMenuFileExit.setMnemonic('X');
    jMenuFileExit.setText("Exit");
    jMenuFileExit.setAccelerator(javax.swing.KeyStroke.getKeyStroke(88, java.awt.event.KeyEvent.CTRL_MASK, false));
    jMenuFileExit.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        jMenuFileExit_actionPerformed(e);
      }
    });
    jMenuHelp.setText("Help");
    jMenuHelpAbout.setText("About");
    jMenuHelpAbout.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        jMenuHelpAbout_actionPerformed(e);
      }
    });


    jPanel1.setBackground(Color.white);
    jPanel1.setLayout(flowLayout1);
    jMenuItem2.setEnabled(false);
    jMenuItem2.setMnemonic('C');
    jMenuItem2.setText("Copy");
    jMenuItem2.setAccelerator(javax.swing.KeyStroke.getKeyStroke(67, java.awt.event.KeyEvent.CTRL_MASK, false));
    jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem2_actionPerformed(e);
      }
    });
    jMenuEdit.setActionCommand("Edit");
    jMenuEdit.setText("Edit");
    flowLayout1.setAlignment(FlowLayout.LEFT);
    borderLayout1.setHgap(3);
    borderLayout1.setVgap(3);
    jMenuItem1.setActionCommand("Save As JPEG");
    jMenuItem1.setMnemonic('J');
    jMenuItem1.setText("Save As JPEG");
    jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem1_actionPerformed(e);
      }
    });
    jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem3_actionPerformed(e);
      }
    });
    jMenuItem3.setMnemonic('B');
    jMenuItem3.setText("Save As BMP");
    jMenuItem4.setMnemonic('T');
    jMenuItem4.setText("Save As TIFF");
    jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem4_actionPerformed(e);
      }
    });
    jMenuItem6.setMnemonic('H');
    jMenuItem6.setText("Set Logo Height");
    jMenuItem6.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem6_actionPerformed(e);
      }
    });
    jMenuItem5.setMnemonic('W');
    jMenuItem5.setText("Set Logo Width");
    jMenuItem5.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem5_actionPerformed(e);
      }
    });
    jTable1.setCellSelectionEnabled(true);
    jTable1.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        jTable1_mouseClicked(e);
      }
    });
    jTable1.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyTyped(KeyEvent e) {
        jTable1_keyTyped(e);
      }
    });

    jMenuItem7.setMnemonic('A');
    jMenuItem7.setText("Add Row");
    jMenuItem7.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem7_actionPerformed(e);
      }
    });
    jMenuItem8.setMnemonic('R');
    jMenuItem8.setText("Remove Row");
    jMenuItem8.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem8_actionPerformed(e);
      }
    });
    jMenuFile.add(jMenuItem3);
    jMenuFile.add(jMenuItem4);
    jMenuFile.add(jMenuItem1);
    jMenuFile.add(jMenuFileExit);
    jMenuHelp.add(jMenuHelpAbout);
    jMenuBar1.add(jMenuFile);
    jMenuBar1.add(jMenuEdit);
    jMenuBar1.add(jMenuHelp);
    this.setJMenuBar(jMenuBar1);
    contentPane.add(statusBar,  BorderLayout.SOUTH);
//    contentPane.add(jScrollPane1, BorderLayout.NORTH);
    contentPane.add(jTabbedPane1,  BorderLayout.CENTER);
    jTabbedPane1.add(jScrollPane1,"Logo");
    jTabbedPane1.add(jScrollPane2, "Data");
    jScrollPane2.getViewport().add(jTable1, null);
    jScrollPane1.getViewport().add(jPanel1, null);
    jMenuEdit.add(jMenuItem7);
    jMenuEdit.add(jMenuItem8);
    jMenuEdit.addSeparator();
    jMenuEdit.add(jMenuItem6);
    jMenuEdit.add(jMenuItem5);
    jMenuEdit.addSeparator();
    jMenuEdit.add(jMenuItem2);
    jTable1.setModel(tmodel);
    jTable1.setValueAt("12",0,0);
    jTable1.setValueAt("5",0,1);
    jTable1.setValueAt("3",0,2);
    jTable1.setValueAt("120",0,3);
    jTable1.setValueAt("140",1,0);
    jTable1.setValueAt("0",1,1);
    jTable1.setValueAt("0",1,2);
    jTable1.setValueAt("0",1,3);
    drawLogo();
  }

  void drawLogo(){
    //remove old components
    jPanel1.removeAll();
    //add new ones
    InfoBar infobar = new InfoBar();
    infobar.setPreferredSize(new Dimension((logoDimension.width)/2,logoDimension.height));
    jPanel1.add(infobar,null);

    SimpleDistributionTrainerContext sdc = new SimpleDistributionTrainerContext();
    for(int i = 0; i<jTable1.getRowCount();i++){// each row of the table
      SimpleDistribution dist = new SimpleDistribution(RNATools.getRNA());
      sdc.registerDistribution(dist);
      try{
      sdc.addCount(dist,RNATools.a(),(new Double((String)jTable1.getValueAt(i,0))).doubleValue());
      sdc.addCount(dist,RNATools.c(),(new Double((String)jTable1.getValueAt(i,1))).doubleValue());
      sdc.addCount(dist,RNATools.g(),(new Double((String)jTable1.getValueAt(i,2))).doubleValue());
      sdc.addCount(dist,RNATools.u(),(new Double((String)jTable1.getValueAt(i,3))).doubleValue());
      sdc.setNullModelWeight(0.00000001);
      sdc.train();

      DistributionLogo logo = new DistributionLogo();
      logo.setPreferredSize(logoDimension);
      logo.setDistribution(dist);
      logo.setStyle(new RNAStyle());
      logo.setLogoPainter(tl2);
      jPanel1.add(logo,null,i+1);
      }catch(Exception ex){
        error(ex);
      }
    }
    repaint();
  }

  /**File | Exit action performed*/
  public void jMenuFileExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }
  /**Help | About action performed*/
  public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
    LogoPaint_About dlg = new LogoPaint_About(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.show();
    repaint();
  }
  /**Overridden so we can exit when window is closed*/
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      jMenuFileExit_actionPerformed(null);
    }
  }

  void jMenuItem2_actionPerformed(ActionEvent e) {
  //copy menu
//    copyLogo();
  }

//  void copyLogo(){
//    Toolkit tk = Toolkit.getDefaultToolkit();
//    Clipboard cb = tk.getSystemClipboard();
//    ls = new LogoSelection(jPanel1);
//    cb.setContents(ls,ls);
//  }

  void jMenuItem1_actionPerformed(ActionEvent e) {
    //save as jpeg
    JFileChooser fileChooser = new JFileChooser(currDir);
    if(fileChooser.showSaveDialog(this) == fileChooser.APPROVE_OPTION){
      File f = fileChooser.getSelectedFile();
      currDir = new File(f.getAbsolutePath());

      try{
      //set up for save image;
      BufferedImage im = new BufferedImage(jPanel1.getWidth(),jPanel1.getHeight(),BufferedImage.TYPE_3BYTE_BGR);
      //write the image
      Graphics2D g2 = im.createGraphics();
      jPanel1.paintAll(g2);
      FileOutputStream fos = new FileOutputStream(f);
      JPEGEncodeParam param = new JPEGEncodeParam();
      ImageEncoder ie = ImageCodec.createImageEncoder("JPEG",fos,param);
      ie.encode(im);
      fos.flush();
      fos.close();
      }catch(Exception ex){
      error(ex);
      }
    }
    repaint();
  }

  void error(Exception ex){
    JOptionPane.showMessageDialog(this, ex.getMessage(),ex.getClass().getName(),JOptionPane.ERROR_MESSAGE);
  }

  void jMenuItem3_actionPerformed(ActionEvent e) {
    JFileChooser fileChooser = new JFileChooser(currDir);
    if(fileChooser.showSaveDialog(this) == fileChooser.APPROVE_OPTION){
      File f = fileChooser.getSelectedFile();
      currDir = new File(f.getAbsolutePath());

      try{
      //set up for save image;
      BufferedImage im = new BufferedImage(jPanel1.getWidth(),jPanel1.getHeight(),BufferedImage.TYPE_3BYTE_BGR);
      //write the image
      Graphics2D g2 = im.createGraphics();
      jPanel1.paintAll(g2);
      FileOutputStream fos = new FileOutputStream(f);
      BMPEncodeParam param = new BMPEncodeParam();
      ImageEncoder ie = ImageCodec.createImageEncoder("BMP",fos,param);
      ie.encode(im);
      fos.flush();
      fos.close();
      }catch(Exception ex){
      error(ex);
      }
    }
    repaint();
  }

  void jMenuItem4_actionPerformed(ActionEvent e) {
    //save as TIFF
    JFileChooser fileChooser = new JFileChooser(currDir);
    if(fileChooser.showSaveDialog(this) == fileChooser.APPROVE_OPTION){
      File f = fileChooser.getSelectedFile();
      currDir = new File(f.getAbsolutePath());

      try{
      //set up for save image;
      BufferedImage im = new BufferedImage(jPanel1.getWidth(),jPanel1.getHeight(),BufferedImage.TYPE_3BYTE_BGR);
      //write the image
      Graphics2D g2 = im.createGraphics();
      jPanel1.paintAll(g2);
      FileOutputStream fos = new FileOutputStream(f);
      TIFFEncodeParam param = new TIFFEncodeParam();
      ImageEncoder ie = ImageCodec.createImageEncoder("TIFF",fos,param);
      ie.encode(im);
      fos.flush();
      fos.close();
      }catch(Exception ex){
      error(ex);
      }
    }
    repaint();
  }

  void jMenuItem6_actionPerformed(ActionEvent e) {
    //set logo height
    String input =JOptionPane.showInputDialog(this,"Set Logo Height","",
                                JOptionPane.QUESTION_MESSAGE);
    logoDimension.height = Integer.parseInt(input);
    for(int i = 0; i<distLogos.size();i++){
      ((Component)distLogos.get(i)).setSize(logoDimension);
    }
    drawLogo();
  }

  void jMenuItem5_actionPerformed(ActionEvent e) {
    //set logo width
    String input =JOptionPane.showInputDialog(this,"Set Logo Width","",
                                JOptionPane.QUESTION_MESSAGE);
    logoDimension.width = Integer.parseInt(input);
    for(int i = 0; i<distLogos.size();i++){
      ((Component)distLogos.get(i)).setSize(logoDimension);
    }
    drawLogo();
  }

  void jTable1_keyTyped(KeyEvent e) {
    //update logo
    drawLogo();
  }

  void jMenuItem8_actionPerformed(ActionEvent e) {
    //remove row
    int r = jTable1.getSelectedRow();
    if(r != -1)tmodel.removeRow(r);
    drawLogo();
  }

  void jMenuItem7_actionPerformed(ActionEvent e) {
    //add row
    int r = jTable1.getSelectedRow();
    if(r == -1){
      tmodel.addRow(new String[]{"0","0","0","0"});
    }else{
      tmodel.insertRow(r,new String[]{"0","0","0","0"});
    }
    drawLogo();
  }

  void jTable1_mouseClicked(MouseEvent e) {
    drawLogo();
  }
}